using System;
using System.Collections;

namespace Quest.Atomic
{
	[Serializable]
	public class Atom
	{
		[NonSerialized]
		public AtomCollection Owner = null;

		public Atom()
		{
		}

		public int ID;

		public override string ToString()
		{
			return ID.ToString();
		}

		public void Delete()
		{
			Owner.Delete(this);
		}

		protected IList Select(Type aFactory)
		{
			return Select(aFactory, this);
		}

		protected IList Select(Type aFactory, System.Reflection.FieldInfo field)
		{
			return Owner.InternalSelect(aFactory, this, field);
		}

		protected IList Select(Type aFactory, Atom filter)
		{
			return Owner.InternalSelect(aFactory, filter);
		}

		public IList SelectCandidates(System.Reflection.FieldInfo field)
		{
			return Owner.InternalSelectCandidates(this, field);
		}

		public static bool IsNull(string value)
		{
			return String.IsNullOrEmpty(value);
		}

		public static bool IsNull(object value)
		{
			if(value == null) return true;
			return IsNull(System.Convert.ToString(value));
		}
	}
}
