using System;
using System.Drawing;

namespace Quest.Graph2D
{
	public interface IGraphElement
	{
		Rectangle Bounds { get; }
		object HitTest(int aX, int anY);
	}

	public class GraphElement
	{
		public static float PixelSize(Graphics canvas, int size)
		{
			PointF[] points = new PointF[]{new PointF(0, 0), new PointF(size, 0)};
			canvas.Transform.TransformPoints(points);
			return points[1].X - points[0].X;
		}
	}

	public interface IGraph
	{
		INodeList NeighboursOf(Node root);
	}
}
