using System;

namespace Structure.Graph2D.IO
{
	public enum NodeShape
	{
		Rectangle,
		Rectangle3D,
		RoundRectangle
	}
	
	public class Node
	{
		public int Id;
		public string Text;
		public System.Drawing.Font Font;
		public NodeShape Shape;
		public System.Drawing.Color ShadowColor;
		public int ShadowSize = 1;
		public System.Drawing.Color BorderColor;
		public System.Drawing.Color BackgroundColor;
		public System.Drawing.Color TextColor;
		public EdgeStyle BorderStyle;
		public string Class;
		
		public System.Drawing.Point Anchor;
		
		public string Description;
		public string Url;
		
		public Node()
		{
			Anchor = new System.Drawing.Point(0, 0);
			ShadowColor = System.Drawing.Color.Empty;
			BorderColor = System.Drawing.Color.Black;
			BackgroundColor = System.Drawing.Color.White;
			TextColor = System.Drawing.Color.Black;
			BorderStyle = EdgeStyle.Normal;
		}
	}
}
