using System;

namespace System.IO.Compression
{
	public interface ICompressedFile: IDisposable
	{
		string Folder
		{
			get;
		}

		bool ReadOnly
		{
			get;
			set;
		}

		void Open(string ArchiveFile, System.IO.FileMode mode, System.IO.FileAccess access);
		
		string CompressedNameToTemporaryName(string fileName);
		string TemporaryNameToCompressedName(string fileName);
		
		/// <summary>
		/// creates new file, preserving case-sensitive names
		/// </summary>
		/// <param name="fileName">compressed name</param>
		/// <returns>corresponding temporary name of the newly createdfile</returns>
		string CreateFile(string fileName);
	}
}
