using System;

namespace System.Windows.Forms
{
	public class IconHelper
	{
		public static void LoadIcon(Form owner, string resourceName)
		{
			LoadIcon(owner, owner.GetType().Name, resourceName);
		}
		
		public static void LoadIcon(Form owner, string container, string resourceName)
		{
			owner.Icon = LoadIcon(container, resourceName);
		}
		
		public static System.Drawing.Icon LoadIcon(string container, string resourceName)
		{
			System.IO.Stream resources = System.Resources.Assembly.GetResourceStream(container + ".resources");
			try
			{
				System.Resources.ResourceReader reader = new System.Resources.ResourceReader(resources);
				try
				{
					foreach(System.Collections.DictionaryEntry entry in reader)
					{
						if (String.Compare(Convert.ToString(entry.Key), resourceName, true) == 0)
						{
							System.Drawing.Icon newIcon = entry.Value as System.Drawing.Icon;
							return newIcon;
						}
					}
				}
				finally
				{
					reader.Close();
				}
			}
			finally
			{
				resources.Dispose();
			}
			return null;
		}
	}
}
